/* Impressive Main 1.0 */

#include <core> 
#include <console> 
#include <string> 
#include <admin> 
#include <adminlib>

new g_Version[] = "1.0";

#define ACCESS_CONSOLE 131072

/*
#define MAX_LOGD_PARAMS	31
new g_LogD_Params[MAX_LOGD_PARAMS][MAX_NAME_LENGTH]=	{{"%P1ID"},{"%P2ID"},{"%P1Name"},{"%P2Name"},
							{"%PIP"},{"%Weap"},{"%P1H"},{"%P1A"},{"%P2H"},
							{"%P2A"},{"%RS"},{"%RE"},{"%RR"},{"%GC"},{"%TAct"},{"%CTSc"},{"%TSc"},
							{"%PAct"},{"%PTeam"},{"%PRole"},{"%spawn_b"},{"%def_w_k"},{"%def_wo_k"},
							{"%got_b"},{"%drop_b"},{"%plant_b"},{"%touch_h"},{"%kill_h"},{"%resc_h"},
							{"%became_v"},{"%kill_v"}};
*/

#define MAX_LOGD_EVENTS 12
#define CONNECT		0
#define ENTER		1
#define DISCONNECT	2
#define SUICIDE		3
#define TEAMSELECT	4
#define ROLESELECT	5
#define KILL		6
#define INJURE		7
#define PVP		8
#define PACTION		9
#define TACTION		10
#define WACTION		11

new g_LogD_Event_Functions[MAX_LOGD_EVENTS][MAX_COMMAND_LENGTH]={{"imp_connect"},{"imp_enter"},{"imp_disconnect"},
								{"imp_suicide"},{"imp_teamselect"},{"imp_roleselect"},
								{"imp_kill"},{"imp_injure"},{"imp_pvp"},
								{"imp_playeraction"},{"imp_teamaction"},{"imp_worldaction"}};

new g_LogD_Event_ID[MAX_LOGD_EVENTS]={50,51,52,53,54,55,57,58,59,60,61,62};

#define MAX_FUNCTIONS	50
new g_Reg_LogD_Event[MAX_FUNCTIONS][3];
new g_Reg_Functions[MAX_FUNCTIONS][20];
new g_Reg_Params[MAX_FUNCTIONS][50];
new g_Reg_Description[MAX_FUNCTIONS][MAX_TEXT_LENGTH];
new g_functions_loaded;

new g_LogD_Event_Loaded[MAX_LOGD_EVENTS];

#define MAX_REGISTRATION 20
new g_Ev_Connect[MAX_REGISTRATION];
new g_Ev_Enter[MAX_REGISTRATION];
new g_Ev_Disconnect[MAX_REGISTRATION];
new g_Ev_Suicide[MAX_REGISTRATION];
new g_Ev_TeamSelect[MAX_REGISTRATION];
new g_Ev_RoleSelect[MAX_REGISTRATION];
new g_Ev_Kill[MAX_REGISTRATION];
new g_Ev_Injure[MAX_REGISTRATION];
new g_Ev_PVP[MAX_REGISTRATION];
new g_Ev_PAction[MAX_REGISTRATION];
new g_Ev_TAction[MAX_REGISTRATION];
new g_Ev_WAction[MAX_REGISTRATION];

new g_plugin=1;

public plugin_init(){
	plugin_registerinfo("Impressive Main 1.0","Initializing Impressive Plugin",g_Version);
	plugin_registercmd("imp_status","imp_status",ACCESS_RCON,"imp_status <eventno.>: displays event with its registered functions"); 
	plugin_registercmd("imp_main_status","imp_status",ACCESS_RCON,"imp_main_status <eventno.>: displays event with its registered functions"); 
	plugin_registercmd("imp_main_load","imp_status",ACCESS_RCON,"imp_main_load <0/1>: switch impressive plugin off/on");
	get_vaultnumdata("IMP_MAIN_PLUGIN",g_plugin);
	if(g_plugin==0){
		selfmessage("[IMP_MAIN] Plugin and its modules are disabled!");
	}else{
		selfmessage("[IMP_MAIN] Plugin and its modules are enabled!");
		read_setup();
	}
	return PLUGIN_CONTINUE;
}

read_setup(){
	new Settings[MAX_TEXT_LENGTH]="addons/adminmod/config/impressive/settings.ini";
	new Data[MAX_DATA_LENGTH];
	new Reg[4];
	new i;
	new iLine;
	new iReg;
	
	if(fileexists(Settings)){
		iLine=filesize(Settings);
		for(i=0;i<=iLine;i++){
			if(g_functions_loaded==MAX_FUNCTIONS){
				selfmessage("[IMP-MAIN]Max. functions registered! Abort!");
				break;
			}
			strinit(Reg);
			strinit(Data);
			iReg=0;
			readfile(Settings,Data,i,MAX_DATA_LENGTH);
			if(strncmp(Data, "//", 2)!=0 && Data[0]!=';' && Data[0]!='#' && strlen(Data)!=0){
				g_functions_loaded++;
				strsplit(Data,",",g_Reg_LogD_Event[g_functions_loaded],4,g_Reg_Functions[g_functions_loaded],20,g_Reg_Params[g_functions_loaded],50,g_Reg_Description[g_functions_loaded],MAX_TEXT_LENGTH);
				iReg=strtonum(g_Reg_LogD_Event[g_functions_loaded]);
				switch(iReg){
					case 50:{
						 g_LogD_Event_Loaded[CONNECT]+=1;
						 g_Ev_Connect[g_LogD_Event_Loaded[CONNECT]]=g_functions_loaded;
						
					}
					case 51:{
						g_LogD_Event_Loaded[ENTER]+=1;
						g_Ev_Enter[g_LogD_Event_Loaded[ENTER]]=g_functions_loaded;
						
					}
					case 52:{
						g_LogD_Event_Loaded[DISCONNECT]+=1;
						g_Ev_Disconnect[g_LogD_Event_Loaded[DISCONNECT]]=g_functions_loaded;
						
					}
					case 53:{
						g_LogD_Event_Loaded[SUICIDE]+=1;
						g_Ev_Suicide[g_LogD_Event_Loaded[SUICIDE]]=g_functions_loaded;
						
					}
					case 54:{
						g_LogD_Event_Loaded[TEAMSELECT]+=1;
						g_Ev_TeamSelect[g_LogD_Event_Loaded[TEAMSELECT]]=g_functions_loaded;
						
					}
					case 55:{
						g_LogD_Event_Loaded[ROLESELECT]+=1;
						g_Ev_RoleSelect[g_LogD_Event_Loaded[ROLESELECT]]=g_functions_loaded;
						
					}
					case 57:{
						g_LogD_Event_Loaded[KILL]+=1;
						g_Ev_Kill[g_LogD_Event_Loaded[KILL]]=g_functions_loaded;
						
					}
					case 58:{
						g_LogD_Event_Loaded[INJURE]+=1;
						g_Ev_Injure[g_LogD_Event_Loaded[INJURE]]=g_functions_loaded;
						
					}
					case 59:{
						g_LogD_Event_Loaded[PVP]+=1;
						g_Ev_PVP[g_LogD_Event_Loaded[PVP]]=g_functions_loaded;
						
					}
					case 60:{
						g_LogD_Event_Loaded[PACTION]+=1;
						g_Ev_PAction[g_LogD_Event_Loaded[PACTION]]=g_functions_loaded;
						
					}
					case 61:{
						g_LogD_Event_Loaded[TACTION]+=1;
						g_Ev_TAction[g_LogD_Event_Loaded[TACTION]]=g_functions_loaded;
						
					}
					case 62:{
						g_LogD_Event_Loaded[WACTION]+=1;
						g_Ev_WAction[g_LogD_Event_Loaded[WACTION]]=g_functions_loaded;
						
					}
				}
			}
		}
		for(i=1;i<MAX_LOGD_EVENTS;i++){
			if(g_LogD_Event_Loaded[i]!=0){
				strinit(Data);
				plugin_registercmd(g_LogD_Event_Functions[i], g_LogD_Event_Functions[i], ACCESS_CONSOLE, "");
				snprintf(Data,MAX_DATA_LENGTH,"logd_reg %i admin_command %s",g_LogD_Event_ID[i],g_LogD_Event_Functions[i]);
				exec( Data );
			}
		}
	}else{
		selfmessage("[IMP-MAIN] settings.ini not found!");
	}	
}

public imp_status(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new i;
	new j;
	new iEvent;
	new x;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	iEvent=strtonum(Data);
	if(strcmp(Command,"imp_main_load")==0){
		selfmessage("");
		if(iEvent==1){
			set_vaultnumdata("IMP_MAIN_PLUGIN",1);
			selfmessage("[IMP_MAIN] Plugin and its modules will be enabled AFTER MAPCHANGE!");
		}else{
			set_vaultnumdata("IMP_MAIN_PLUGIN",0);
			selfmessage("[IMP_MAIN] Plugin and its modules will be disabled AFTER MAPCHANGE!");
		}
		selfmessage("");
	}else{
		
		
		for(i=0;i<=MAX_LOGD_EVENTS;i++){
			if(iEvent==g_LogD_Event_ID[i]){
				x=1;
				break;
			}
		}
		selfmessage("");
		selfmessage("IMPRESSIVE-REGISTRATION:");
		if(x){
			snprintf(Text,MAX_TEXT_LENGTH,"Event %i",iEvent);
			selfmessage(Text);
			selfmessage("---------------------------");
			for(j=1;j<=g_functions_loaded;j++){
				if(strcmp(g_Reg_LogD_Event[j][0],Data)==0){
					strinit(Text);
					snprintf(Text,MAX_TEXT_LENGTH,"*(%i) %s^n%s^t^t%s",j,g_Reg_Description[j],g_Reg_Functions[j],g_Reg_Params[j]);
					selfmessage(Text);
				}
			}
		}else{
			selfmessage("");
			selfmessage("Event ID not found!");
			selfmessage("---------------------------");
		}
	}
	return PLUGIN_HANDLED;
}

//50
public imp_connect(HLCommand,HLData){
	new Data[MAX_NAME_LENGTH];
	new strUserName[MAX_NAME_LENGTH];
	new strUserIndex[MAX_NUMBER_LENGTH];
	new IP[MAX_NAME_LENGTH];
	new iUI;
	new i;
	
	convert_string(HLData, Data, MAX_NAME_LENGTH);
	strbreak(Data,strUserIndex,IP,MAX_DATA_LENGTH);
	
	iUI=strtonum(strUserIndex);
	if(iUI!=0){
		playerinfo(iUI,strUserName,MAX_NAME_LENGTH);
		for(i=1;i<= g_LogD_Event_Loaded[CONNECT];i++){
			strinit(Data);
			strcpy(Data,g_Reg_Params[g_Ev_Connect[i]][0],50);
			strsubst(Data," ","",MAX_DATA_LENGTH);
			strsubst(Data,"&P1ID",strUserIndex,MAX_DATA_LENGTH);
			strsubst(Data,"&P1Name",strUserName,MAX_DATA_LENGTH);
			strsubst(Data,"&IP",IP,MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_Connect[i]],Data);
		}
	}
	return PLUGIN_CONTINUE;
}

//51
public imp_enter(HLCommand,HLData){
	new Data[MAX_NAME_LENGTH];
	new strUserName[MAX_NAME_LENGTH];
	new strUserIndex[MAX_NUMBER_LENGTH];
	new iUI;
	new i;
	
	convert_string(HLData, strUserIndex, MAX_NAME_LENGTH);
	
	iUI=strtonum(strUserIndex);
	if(iUI!=0){
		playerinfo(iUI,strUserName,MAX_NAME_LENGTH);
		for(i=1;i<=g_LogD_Event_Loaded[ENTER];i++){
			strinit(Data);
			strcpy(Data,g_Reg_Params[g_Ev_Enter[i]][0],50);
			strsubst(Data," ","",MAX_DATA_LENGTH);
			strsubst(Data,"&P1ID",strUserIndex,MAX_DATA_LENGTH);
			strsubst(Data,"&P1Name",strUserName,MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_Enter[i]],Data);
		}
	}
	return PLUGIN_CONTINUE;
}

//52
public imp_disconnect(HLCommand,HLUserIndex){
	new Data[MAX_NAME_LENGTH];
	new strUserName[MAX_NAME_LENGTH];
	new strUserIndex[MAX_NUMBER_LENGTH];
	new iUI;
	new i;
	
	convert_string(HLUserIndex, strUserIndex, MAX_NAME_LENGTH);
	
	iUI=strtonum(strUserIndex);
	if(iUI!=0){
		playerinfo(iUI,strUserName,MAX_NAME_LENGTH);
		for(i=1;i<=g_LogD_Event_Loaded[DISCONNECT];i++){
			strinit(Data);
			strcpy(Data,g_Reg_Params[g_Ev_Disconnect[i]][0],50);
			strsubst(Data," ","",MAX_DATA_LENGTH);
			strsubst(Data,"&P1ID",strUserIndex,MAX_DATA_LENGTH);
			strsubst(Data,"&P1Name",strUserName,MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_Disconnect[i]],Data);
		}
	}
	return PLUGIN_CONTINUE;
}

//53
public imp_suicide(HLCommand,HLData){
	new Data[MAX_DATA_LENGTH];
	new strUserName[MAX_NAME_LENGTH];
	new strUserIndex[MAX_NUMBER_LENGTH];
	new Weapon[MAX_NAME_LENGTH];
	new iUI;
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	strbreak(Data,strUserIndex,Weapon,MAX_DATA_LENGTH);
	
	iUI=strtonum(strUserIndex);
	if(iUI!=0){
		playerinfo(iUI,strUserName,MAX_NAME_LENGTH);
		
		for(i=1;i<=g_LogD_Event_Loaded[SUICIDE];i++){
			strinit(Data);
			strcpy(Data,g_Reg_Params[g_Ev_Suicide[i]][0],50);
			strsubst(Data," ","",MAX_DATA_LENGTH);
			strsubst(Data,"&P1ID",strUserIndex,MAX_DATA_LENGTH);
			strsubst(Data,"&P1Name",strUserName,MAX_DATA_LENGTH);
			strsubst(Data,"&Weap",Weapon,MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_Suicide[i]],Data);
		}
	}
	return PLUGIN_CONTINUE;
}

//57
public imp_kill(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new sAttacker[3];
	new sVictim[3];
	new Weapon[MAX_NAME_LENGTH];
	new strAttacker[MAX_NAME_LENGTH];
	new strVictim[MAX_NAME_LENGTH];
	new iAhealth;
	new strAHealth[4];
	new iAarmor;
	new strAArmor[4];
	new iA;
	new iV;
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strsplit(Data," ",sAttacker,3,sVictim,3,Weapon,MAX_NAME_LENGTH);
	iA=strtonum(sAttacker);
	iV=strtonum(sVictim);
	
	if(iA!=0){
		playerinfo(iA,strAttacker,MAX_NAME_LENGTH);
		get_userHealth(strAttacker, iAhealth);
		numtostr(iAhealth,strAHealth);
		get_userArmor(strAttacker, iAarmor);
		numtostr(iAarmor,strAArmor);
	}
	if(iV!=0){
		playerinfo(iV,strVictim,MAX_NAME_LENGTH);
	}
	for(i=1;i<=g_LogD_Event_Loaded[KILL];i++){
		strinit(Data);
		strcpy(Data,g_Reg_Params[g_Ev_Kill[i]][0],50);
		strsubst(Data," ","",MAX_DATA_LENGTH);
		strsubst(Data,"&P1ID",sAttacker,MAX_DATA_LENGTH);
		strsubst(Data,"&P2ID",sVictim,MAX_DATA_LENGTH);
		strsubst(Data,"&Weap",Weapon,MAX_DATA_LENGTH);
		strsubst(Data,"&P1Name",strAttacker,MAX_DATA_LENGTH);
		strsubst(Data,"&P2Name",strVictim,MAX_DATA_LENGTH);
		strsubst(Data,"&P1H",strAHealth,MAX_DATA_LENGTH);
		strsubst(Data,"&P1A",strAArmor,MAX_DATA_LENGTH);
		plugin_exec(g_Reg_Functions[g_Ev_Kill[i]],Data);
	}
	return PLUGIN_CONTINUE;
}

//58
public imp_injure(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new sAttacker[3];
	new sVictim[3];
	new Weapon[MAX_NAME_LENGTH];
	new strAttacker[MAX_NAME_LENGTH];
	new strVictim[MAX_NAME_LENGTH];
	new strDamage[MAX_NUMBER_LENGTH];
	new iAhealth;
	new strAHealth[4];
	new iAarmor;
	new strAArmor[4];
	new iVhealth;
	new strVHealth[4];
	new iVarmor;
	new strVArmor[4];
	new iA;
	new iV;
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
		
	strsplit(Data," ",sAttacker,3,sVictim,3,Weapon,MAX_NAME_LENGTH,strDamage,MAX_NUMBER_LENGTH);
	strsplit(strDamage,"#",strDamage,MAX_NUMBER_LENGTH,strDamage,MAX_NUMBER_LENGTH);
	iA=strtonum(sAttacker);
	iV=strtonum(sVictim);
	
	if(iA!=0){
		playerinfo(iA,strAttacker,MAX_NAME_LENGTH);
		get_userHealth(strAttacker, iAhealth);
		numtostr(iAhealth,strAHealth);
		get_userArmor(strAttacker, iAarmor);
		numtostr(iAarmor,strAArmor);
	}
	if(iV!=0){
		playerinfo(iV,strVictim,MAX_NAME_LENGTH);
		get_userHealth(strVictim, iVhealth);
		numtostr(iVhealth,strVHealth);
		get_userArmor(strVictim, iVarmor);
		numtostr(iVarmor,strVArmor);
	}
	for(i=1;i<=g_LogD_Event_Loaded[INJURE];i++){
		strinit(Data);
		strcpy(Data,g_Reg_Params[g_Ev_Injure[i]][0],50);
		strsubst(Data," ","",MAX_DATA_LENGTH);
		strsubst(Data,"&P1ID",sAttacker,MAX_DATA_LENGTH);
		strsubst(Data,"&P2ID",sVictim,MAX_DATA_LENGTH);
		strsubst(Data,"&Weap",Weapon,MAX_DATA_LENGTH);
		strsubst(Data,"&Dam",strDamage,MAX_DATA_LENGTH);
		strsubst(Data,"&P1Name",strAttacker,MAX_DATA_LENGTH);
		strsubst(Data,"&P2Name",strVictim,MAX_DATA_LENGTH);
		strsubst(Data,"&P1H",strAHealth,MAX_DATA_LENGTH);
		strsubst(Data,"&P1A",strAArmor,MAX_DATA_LENGTH);
		strsubst(Data,"&P2H",strVHealth,MAX_DATA_LENGTH);
		strsubst(Data,"&P2A",strVArmor,MAX_DATA_LENGTH);
		plugin_exec(g_Reg_Functions[g_Ev_Injure[i]],Data);
	}
	return PLUGIN_CONTINUE;
}

//55
public imp_playeraction(HLCommand,HLData){
	new i;
	new Data[MAX_DATA_LENGTH];
	new Dummy[MAX_DATA_LENGTH];
	new sP1ID[3];
	new sP1Name[MAX_NAME_LENGTH];
	new sP1Health[4];
	new sP1Armor[4];
	new iP1health;
	new iP1armor;
	new iP1ID;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strbreak(Data,sP1ID,Dummy,MAX_DATA_LENGTH);
	if(strlen(sP1ID)!=0){
		iP1ID=strtonum(sP1ID);
		playerinfo(iP1ID,sP1Name,MAX_NAME_LENGTH);
		get_userHealth(sP1Name, iP1health);
		numtostr(iP1health,sP1Health);
		get_userArmor(sP1Name, iP1armor);
		numtostr(iP1armor,sP1Armor);
	}
	for(i=1;i<=g_LogD_Event_Loaded[PACTION];i++){
		strinit(Data);
		strcpy(Data,g_Reg_Params[g_Ev_PAction[i]][0],50);
		strsubst(Data," ","",MAX_DATA_LENGTH);
		strsubst(Data,"&P1ID",sP1ID,MAX_DATA_LENGTH);
		strsubst(Data,"&P1Name",sP1Name,MAX_DATA_LENGTH);
		strsubst(Data,"&P1H",sP1Health,MAX_DATA_LENGTH);
		strsubst(Data,"&P1A",sP1Armor,MAX_DATA_LENGTH);
		if(strcmp(Dummy,"Spawned_With_The_Bomb")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&spawn_b")!=-1){
			strsubst(Data,"&spawn_b"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Begin_Bomb_Defuse_With_Kit")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&def_w_k")!=-1){
			strsubst(Data,"&&def_w_k"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Begin_Bomb_Defuse_Without_Kit")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&def_wo_k")!=-1){
			strsubst(Data,"&&def_wo_k"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Got_The_Bomb")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&got_b")!=-1){
			strsubst(Data,"&got_b"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Dropped_The_Bomb")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&drop_b")!=-1){
			strsubst(Data,"&drop_b"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Planted_The_Bomb")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&plant_b")!=-1){
			strsubst(Data,"&plant_b"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Touched_A_Hostage")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&touch_h")!=-1){
			strsubst(Data,"&touch_h"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Killed_A_Hostage")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&kill_h")!=-1){
			strsubst(Data,"&kill_h"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Rescued_A_Hostage")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&resc_h")!=-1){
			strsubst(Data,"&resc_h"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"Became_VIP")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&became_v")!=-1){
			strsubst(Data,"&became_v"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}else if(strcmp(Dummy,"VIP_Assassinated")==0 && strstrx(g_Reg_Params[g_Ev_PAction[i]],"&kill_v")!=-1){
			strsubst(Data,"&kill_v"," ",MAX_DATA_LENGTH);
			plugin_exec(g_Reg_Functions[g_Ev_PAction[i]],Data);
		}
	}
	return PLUGIN_CONTINUE;
}

//61
public imp_teamaction(HLCommand,HLData,HLUserName,UserIndex){
	new Params[MAX_DATA_LENGTH];
	new Team[MAX_DATA_LENGTH];
	new Data[MAX_DATA_LENGTH]; 
	new TAction[MAX_NAME_LENGTH];                               
	new Dummy[MAX_DATA_LENGTH];
	new CTScore[6];
	new TScore[6];
	new i;
	
	convert_string(HLData,Params,MAX_DATA_LENGTH);
                    
        strbreak(Params,Team,Data,MAX_DATA_LENGTH);
	strsplit(Data, "# " ,TAction,MAX_DATA_LENGTH,Dummy,MAX_DATA_LENGTH,CTScore,6,Dummy,MAX_DATA_LENGTH,TScore,6);
	for(i=1;i<=g_LogD_Event_Loaded[TACTION];i++){
		strinit(Data);
		strcpy(Data,g_Reg_Params[g_Ev_TAction[i]][0],50);
		strsubst(Data," ","",MAX_DATA_LENGTH);
		strsubst(Data,"&Team",Team,MAX_DATA_LENGTH);
		strsubst(Data,"&TAct",TAction,MAX_DATA_LENGTH);
		strsubst(Data,"&CTSc",CTScore,MAX_DATA_LENGTH);
		strsubst(Data,"&TSc",TScore,MAX_DATA_LENGTH);
		plugin_exec(g_Reg_Functions[g_Ev_TAction[i]],Data);
	}
        return PLUGIN_CONTINUE;
}

//62
public imp_worldaction(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new i;
		
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	
        if(Data[0]=='G'){
       		for(i=1;i<=g_LogD_Event_Loaded[WACTION];i++){
       			if(strstrx(g_Reg_Params[g_Ev_WAction[i]],"&GC")!=-1){
				plugin_exec(g_Reg_Functions[g_Ev_WAction[i]],Data);
			}
		}
	}else if(Data[8]=='R'){
		for(i=1;i<=g_LogD_Event_Loaded[WACTION];i++){
       			if(strstrx(g_Reg_Params[g_Ev_WAction[i]],"&RR")!=-1){
				plugin_exec(g_Reg_Functions[g_Ev_WAction[i]],Data);
			}
		}
	}else if(Data[6]=='S'){
		for(i=1;i<=g_LogD_Event_Loaded[WACTION];i++){
       			if(strstrx(g_Reg_Params[g_Ev_WAction[i]],"&RS")!=-1){
				plugin_exec(g_Reg_Functions[g_Ev_WAction[i]],Data);
			}
		}
	}else if(Data[6]=='E'){
		for(i=1;i<=g_LogD_Event_Loaded[WACTION];i++){
       			if(strstrx(g_Reg_Params[g_Ev_WAction[i]],"&RE")!=-1){
				plugin_exec(g_Reg_Functions[g_Ev_WAction[i]],Data);
			}
		}
	}
        return PLUGIN_CONTINUE;
}