/* 	
Impressive TEAM-ATTACK-Modul 1.0 by Sir D.

Feature:
- Slayed den TAler innerhalb der ersten X Sekunden nach Rundenstart

Bentigt:
- plugin_sdal_imp_main.amx
- installiertes LogD und mp_logdetail 3 in server.cfg (logd_block 58, um die Injure-Logs abzublocken)
- amv_enable_menu "menu1" in der adminmod.cfg

Befehle:
- imp_ta_plugin '0/1'	:schaltet das Plugin aus/an
- imp_ta_time '1-300'	:setzt das Zeitfenster nach Rundenstart in Sekunden
vault.ini:
- IMP_TA_PLUGIN 0/1
- IMP_TA_TIME 1-x

settings.ini des sdal_imp_main im Ordner addons/adminmod/config/impressive:
- 58,imp_ta_injure,%P1ID %Weap %Dam,TEAM-ATTACK Modul
- 62,imp_ta_newr,%RS,TEAM-ATTACK Modul

*/

#include <core> 
#include <console> 
#include <string> 
#include <admin> 
#include <adminlib>

new g_Version[] = "1.0";

#define ACCESS_CONSOLE 131072

new g_plugin=1;
new g_time=8;
new g_punish=0;

public plugin_init(){
	new Menu[MAX_NAME_LENGTH];
	getstrvar("amv_enable_beta",Menu,MAX_NAME_LENGTH);
	if(strstrx(Menu,"menu1")==-1){
		plugin_registerinfo("TEAM-ATTACK Modul","Disabled!^nMissing 'amv_enable_beta menu1' in adminmod.cfg",g_Version);
	}else{
		plugin_registerinfo("TEAM-ATTACK Modul","Kills teamattacker who attack during x seconds after round start",g_Version);
		plugin_registercmd("imp_ta","imp_ta_settings",ACCESS_MAP,"imp_ta: show plugin settings");
		plugin_registercmd("imp_ta_plugin","imp_ta_settings",ACCESS_MAP,"imp_ta_plugin '0/1': Turns plugin off/on");
		plugin_registercmd("imp_ta_time","imp_ta_settings",ACCESS_MAP,"imp_ta_time '1-300': period after round start for detecting and punishing teamattack.");
		plugin_registercmd("imp_ta_injure","imp_ta_injure",ACCESS_CONSOLE);
		plugin_registercmd("imp_ta_newr","imp_ta_newr",ACCESS_CONSOLE);
		get_vaultnumdata("IMP_TA_PLUGIN",g_plugin);
		if(g_plugin==0){
			selfmessage("[IMP_TEAMATTACK] Plugin is disabled!");
		}			
		get_vaultnumdata("IMP_TA_TIME",g_time);
		if(g_time==0){
			g_time=8;
		}
	}
		
	return PLUGIN_CONTINUE;
}

public imp_ta_settings(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new i;
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		i=strtonum(Data);
		strcpy(Command,Command[7],MAX_COMMAND_LENGTH);
		if(Command[0]=='p'){
			if(i<0 || i>1){
				i=1;
			}
			set_vaultnumdata("IMP_TA_PLUGIN",i);
			g_plugin=i;
		}else{
			if(i<1 || i>300){
				i=8;
			}
			set_vaultnumdata("IMP_TA_TIME",i);
			g_time=i;
		}	
	}
	selfmessage("");
	snprintf(Text,MAX_TEXT_LENGTH,"IMPRESSIVE TEAM-ATTACK-MODUL (v.%s):",g_Version);
	selfmessage(Text);
	selfmessage("-----------------------------");
	snprintf(Text,MAX_TEXT_LENGTH,"* Plugin is set to %i",g_plugin);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* TA-DETECT-TIME is set to %i",g_time);
	selfmessage(Text);
	selfmessage("");
	return PLUGIN_HANDLED;
}

public imp_ta_injure(HLCommand,HLData,HLUserName,UserIndex){
	if(g_punish){
		new Data[MAX_DATA_LENGTH];
		new Attacker[MAX_NAME_LENGTH];
		new Victim[MAX_NAME_LENGTH];
		new P1ID[3];
		new P2ID[3];
		new p1;
		new p2;
		new iATeam;
		new iVTeam;
		
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		strsplit(Data,"",P1ID,3,P2ID,3);
		p1=strtonum(P1ID);
		p2=strtonum(P2ID);
		if(playerinfo(p1,Attacker,MAX_NAME_LENGTH,_,_,iATeam)){
			if(playerinfo(p2,Victim,MAX_NAME_LENGTH,_,_,iVTeam)){
				if(iATeam==iVTeam){
					slay(Attacker);
					menu(Attacker,"\rTeamattacks^n^nwerden bei uns^n^nnicht geduldet!!!",1023,10);
				}
			}
		}
		/*
		strinit(Data);
		snprintf(Data,MAX_DATA_LENGTH,"%s - %s Team:%i - Team:%i",Attacker, Victim, iATeam, iVTeam);
		say(Data);
		*/
	}	
	return PLUGIN_HANDLED;
}

public imp_ta_newr(HLCommand,HLData,HLUserName,UserIndex){
	g_punish=1;
	set_timer("punish_off",g_time,0);
	return PLUGIN_HANDLED;
}

public punish_off(Timer,Repeat,HLName,HLParam) {
	g_punish=0;
	return PLUGIN_CONTINUE;
}